<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class ABAgendaController extends TeknisaCrud {
    
    protected $newCode;
    protected $environment;
    protected $entityManager;
    protected $connection;
    protected $agendaService;
    protected $parceiroService;
    
    public function __construct ($crudService, $parameterBag, $entityManager, $newCode, $environment, $agendaService, $parceiroService, $controlerNovaTarefa){
        
        $this->connection                   = $entityManager->getConnection();
        $this->newCode                      = $newCode;
        $this->entityManager                = $entityManager;
        $this->environment                  = $environment;
        $this->agendaService                = $agendaService;
        $this->controlerNovaTarefa          = $controlerNovaTarefa;
        
        parent::__construct($crudService, $parameterBag);
    }
    
    public function generalInsertTask(Row $row, Response $response){
        $row = $row->getRow();
        
        $row["NRSEQFILACONTA"] = $this->newCode->getCodeByTableName("FILACONTATO", $row["NRORG"]);
        $retorno = $this->agendaService->generalInsertTask($row);
        
        if($retorno != $row["NRSEQFILACONTA"]){
            $response->setError(new Error(array("ERRO" => $retorno, "MESSAGE" => 'Não foi possível criar a tarefa.'), 10));
        }else{
            $response->addDataSet(new DataSet("DADOS", array("NRSEQFILACONTA" => $retorno)));
        }
        
         
        if($row["CDOPEREVOL"] != $row["CDOPERREAL"] && !empty($row["DSEMAILOPER"])){
            $paramsEmail = array(
                "TIPO"                  => "",
                "NMOPERREAL"            => empty($row["NMOPERADORREAL"]) ? '' : $row["NMOPERADORREAL"],
                "OPERADORDOLOGADO"      => empty($row["NMOPERADOR"]) ? '' : $row["NMOPERADOR"],
                "DSTIPO"                => null,
                "DESCRICAO"             => null,
                "NRSEQCONTATO"          => null,
                "DSFILACONTATO"         => empty($row["DSFILACONTATO"]) ? '' : $row["DSFILACONTATO"],
                "NMPARCNEGOCIO"         => empty($row["NMPARCNEGOCIO"]) ? '' : $row["NMPARCNEGOCIO"],
                "DTPLANFILACONTA"       => empty($row["DTPLANFILACONTA"]) ? '' : $row["DTPLANFILACONTA"],
                "DTVENCFILACONTA"       => null,
                "DSCLASSIFICATAREFA"    => null,
                "DSDETEFILACONTA"       => null,
                "DSEMAILOPER"           => empty($row["DSEMAILOPER"]) ? '' : $row["DSEMAILOPER"]
                );
            $this->controlerNovaTarefa->enviaEmailTarefa($paramsEmail);
        }
    }
    
}