<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO;


class TermometroOportunidadeController extends TeknisaCrud
{
    protected $dataSourceName = 'crm_termoportuni';
    
    public function save(DTO\Request $request, DTO\Response $response) {
        try {
            foreach ($request->getDataSet()->getRows() as &$row) {
                if (array_key_exists('NRTERMOPORTUNI', $row)) {
                    if ($row['__is_new']) {
                        $row['NRTERMOPORTUNI'] = NovoCodigo::geraCodigo($row['NRORG'], "CRM_TERMOPORTUNI", 1, 5, false, false);
                    }
                } else {
                    $row['NRTERMOPORTUNI'] = NovoCodigo::geraCodigo($row['NRORG'], "CRM_TERMOPORTUNI", 1, 5, false, false);
                }
            
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}