<?php
namespace Teknisa\CRM\Controller;

use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class crm00050000ComunicaRevendaController extends TeknisaCrud
{
    protected $dataSourceName = 'crm_comunicarevenda';
    protected $parameterBagColumns = array('P_NRORGPADRAO');
    protected $comunicaRevendaService;
    
    public function __construct($crudService, $parameterBag, $comunicaRevendaService){
        
        $this->comunicaRevendaService = $comunicaRevendaService;
        
        parent::__construct($crudService, $parameterBag);
    }
    
    public function save(Request $request, Response $response) {
        parent::save($request, $response);
        
	    $columnsToReturn = $this->crudService->getColumnsToReturn();
	    
        $retorno = array();
        if (count($columnsToReturn) > 0)
            $retorno["NRCOMUNICAREVENDA"] = $columnsToReturn[0]["NRCOMUNICAREVENDA"];
	    
	    $response->addDataSet(new DataSet("columnsToReturn", $retorno));
    }
    
    public function insertNewPartnerCommunication(Row $row, Response $response){

        $row = $row->getRow();
        
        $nrCdComuncaParc = $this->comunicaRevendaService->callForInsertNewPartnerCommunication($row);
        
        $response->addDataSet(new DataSet("DADOS", array("NRCOMUNICAPARC" => $nrCdComuncaParc)));
        
    }
}
?>