<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class ChamadoFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }

    public function transfereOperador($paramsTransferOper){

        $update = "UPDATE CONTATO SET CDOPERCONT = :CDOPERADOR, CDOPERULTATU = :CDOPERULTATU, DTULTATU = :DTULTATU, NRORGULTATU = :NRORG, IDNOVOTICKET = 'S'
                        WHERE NRSEQCONTATO = :NRSEQCONTATO AND NRORG = :NRORG";
                 
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsTransferOper);
            return $paramsTransferOper['NRSEQCONTATO'];
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getNrparcnegocioCliente($paramsGetNrparcCliente){

        $update = "SELECT CLIE.NRPARCNEGOCIO NRPARCNEGOCIO FROM OPERADOR OP LEFT JOIN CLIENTE CLIE ON OP.CDCLIENTE = CLIE.CDCLIENTE AND OP.NRORG = CLIE.NRORG
                        WHERE OP.CDOPERADOR = :CDOPERADOR AND OP.NRORG = :NRORG";
                 
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsGetNrparcCliente);
            $return = $std->fetchAll();
            if(!empty($return))
                return $return[0]['NRPARCNEGOCIO'];
            else 
                return array();
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function getComunicaparc($paramsGetNrparcEstrutura){

        $update = "SELECT CDCOMUNICAPARC FROM COMUNICAPARC
                        WHERE CDCOMUNICAPARC = :CDCOMUNICAPARC 
                            AND CDFORMACOMU in(:CDFORMACOMU)
                            AND NRPARCNEGOCIO = :NRPARCNEGOCIO
                            AND NRORG = :NRORG";
                 
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsGetNrparcEstrutura);
            $return = $std->fetchAll();
            if(!empty($return))
                return $return[0]['CDCOMUNICAPARC'];
            else 
                return array();
            
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function insertComunicaparc($paramsTransferOper){

        $update = "INSERT INTO COMUNICAPARC (CDCOMUNICAPARC, IDATIVO, DTINCLUSAO, NRCOMUNICAPARC, NRPARCNEGOCIO, CDFORMACOMU, NRORG)
                    VALUES (:CDCOMUNICAPARC, :IDATIVO, SYSDATE, :NRCOMUNICAPARC, :NRPARCNEGOCIO, :CDFORMACOMU, :NRORG)";
                 
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsTransferOper);
            return true;
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
}
    