CREATE OR REPLACE TRIGGER USR_EXCLUSAO_EXPORTAREDZ
AFTER DELETE ON REDUCAOZ FOR EACH ROW
DECLARE
   V_DTGRV        DATE;
   V_HRGRV        VARCHAR2(04);

   V_NOVOCODIGO    INTEGER;
   V_FILIAL        VARCHAR2(10);
BEGIN
   V_DTGRV := NULL;
   V_HRGRV := NULL;

   /* Retorna data e hora de exportao */
   BEGIN
      SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
        INTO V_DTGRV, V_HRGRV
        FROM DUAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_DTGRV := NULL;
         V_HRGRV := NULL;
   END;

   SELECT MAX(CDGRUPFILI)
     INTO V_FILIAL
     FROM FILGRUPFILI
    WHERE CDFILIAL = :OLD.CDFILIAL
      AND USR_IDPROTHEUS = 'S';

   IF NOT V_FILIAL IS NULL THEN

      FOR C_USR_ZWD IN (
         SELECT CDFILIAL, CDCAIXA, NRECFREDZ, DTREDUCAOZ,
                WD_EMPRESA, WD_FILIAL , WD_DTMOVTO,
                WD_PDV    ,
                WD_SERPDV ,
                WD_NUMREDZ,
                WD_GTFINAL,
                WD_NUMINI , WD_NUMFIM ,
                WD_CANCEL , WD_VALCON ,
                WD_DESC   , WD_SUBTRIB,
                WD_ISENTO , WD_NTRIB  ,
                WD_ISS    , WD_CRO    ,
                WD_COO    , WD_OUTROSR,
                WD_NUMERO , WD_GTINI  ,
                WD_IMPDEBT,
                WD_BAS7, WD_BAS12, WD_BAS18, WD_BAS25
           FROM USR_ZWD
          WHERE CDFILIAL = :OLD.CDFILIAL
            AND CDCAIXA = :OLD.CDCAIXA
            AND NRECFREDZ = :OLD.NRECFREDZ
            AND DTREDUCAOZ = :OLD.DTREDUCAOZ) LOOP

         /* Retorna o sequencial para a tabela */
         BEGIN
            SELECT WD_IDREDZ.NEXTVAL
              INTO V_NOVOCODIGO
              FROM DUAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NOVOCODIGO := 1;
         END;

         INSERT INTO USR_ZWD
            (CDFILIAL, CDCAIXA, NRECFREDZ, DTREDUCAOZ,
             WD_IDREDZ, WD_EMPRESA, WD_FILIAL , WD_DTMOVTO,
             WD_PDV    ,
             WD_SERPDV ,
             WD_NUMREDZ,
             WD_GTFINAL,
             WD_NUMINI , WD_NUMFIM ,
             WD_CANCEL , WD_VALCON ,
             WD_DESC   , WD_SUBTRIB,
             WD_ISENTO , WD_NTRIB  ,
             WD_ISS    , WD_CRO    ,
             WD_COO    , WD_OUTROSR,
             WD_NUMERO , WD_GTINI  ,
             WD_IMPDEBT, WD_TPEDI,
             WD_BAS7, WD_BAS12, WD_BAS18, WD_BAS25,
             WD_DTGRV, WD_HRGRV, WD_DTIMP, WD_HRIMP)
         VALUES
            (C_USR_ZWD.CDFILIAL, C_USR_ZWD.CDCAIXA, C_USR_ZWD.NRECFREDZ, C_USR_ZWD.DTREDUCAOZ,
             V_NOVOCODIGO, C_USR_ZWD.WD_EMPRESA, C_USR_ZWD.WD_FILIAL , C_USR_ZWD.WD_DTMOVTO,
             C_USR_ZWD.WD_PDV    ,
             C_USR_ZWD.WD_SERPDV ,
             C_USR_ZWD.WD_NUMREDZ,
             C_USR_ZWD.WD_GTFINAL,
             C_USR_ZWD.WD_NUMINI , C_USR_ZWD.WD_NUMFIM ,
             C_USR_ZWD.WD_CANCEL , C_USR_ZWD.WD_VALCON ,
             C_USR_ZWD.WD_DESC   , C_USR_ZWD.WD_SUBTRIB,
             C_USR_ZWD.WD_ISENTO , C_USR_ZWD.WD_NTRIB  ,
             C_USR_ZWD.WD_ISS    , C_USR_ZWD.WD_CRO    ,
             C_USR_ZWD.WD_COO    , C_USR_ZWD.WD_OUTROSR,
             C_USR_ZWD.WD_NUMERO , C_USR_ZWD.WD_GTINI  ,
             C_USR_ZWD.WD_IMPDEBT, '2',
             C_USR_ZWD.WD_BAS7, C_USR_ZWD.WD_BAS12, C_USR_ZWD.WD_BAS18, C_USR_ZWD.WD_BAS25,
             V_DTGRV, V_HRGRV, NULL, '');
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXCLUSAO_EXPORTAREDZ','5.09.000'); END;
/
