/* global Util, MetadataEnrichment, ShowInDevTools */
function ContainerDecoratorDeveloper(ZHPromise, templateManager) {
	this.apply = function(containerName, container) {
		if (containerName && container && Util.isObject(container)) {
			MetadataEnrichment.enrich(container);
			ShowInDevTools.setTree(container);
			container.events = container.events || [];
			container.events.push({
				"name": "ContainerOnRender",
				"code": "args.owner.render()"
			});

			var widgetEventFunction = function(widget) {
				var widgetEvent = {
					"name": "WidgetOnRender",
					"code": "args.owner.redraw()"
				};
				widget.events = widget.events || [];
				widget.events.push(widgetEvent);
			};

			var _eachWidget = function(widget, f) {
				f(widget);
				if (widget.widgets) {
					widget.widgets.forEach(function(widget) {
						_eachWidget(widget, f);
					});
				}
			};
			if (container.widgets) {
				container.widgets.forEach(function(widget) {
					_eachWidget(widget, widgetEventFunction);
				});
			}
		}
		return ZHPromise.when(container);
	};
}