/*global
angular
*/
var ZeedhiDirectives = angular.module("ZeedhiDirectives");

ZeedhiDirectives.directive('zhHideDeveloperTree', function(eventAggregator, templateManager) {
	return {
		link: function($scope, $element, $attributes, $controller) {
			var CODE_ELEMENT_SELECTOR = '.editor';
			var TREE_ELEMENT_SELECTOR = '.components-tree';
			var SHOW = "show";
			var HIDE = "hide";
			var visibilityOfTree;

			var treeIsHidden = function(){
				return visibilityOfTree === HIDE;
			};
			$scope.treeIsHidden = treeIsHidden;

			var getElement = function(elementName){
				return $element.find(elementName);
			};

			var setWidthInElement = function(elementName, width){
				getElement(elementName).width(width);
				templateManager.updateTemplate();
			};

			var changeCodeContainerWidth = function(){
				var currentWidth = window.innerWidth;
				var widthOfComponentsTree = 200;
				var finalWidth = treeIsHidden() ? currentWidth - 1 : currentWidth - widthOfComponentsTree;
				setWidthInElement(CODE_ELEMENT_SELECTOR, finalWidth);
			};

			var changeTreeVisibility = function(){
				var widthOfTree = 199;
				var finalWidth = treeIsHidden() ? 0 : widthOfTree;
				setWidthInElement(TREE_ELEMENT_SELECTOR, finalWidth);
			};

			eventAggregator.subscribe('developerEnableHideMode', function(args){
				visibilityOfTree = args ? HIDE : SHOW;
				changeCodeContainerWidth();
				changeTreeVisibility();
			});

			$(window).resize(function(){
				var width = window.innerWidth;
				var treeWidth = getElement(TREE_ELEMENT_SELECTOR).width() + 1;
				width = width - treeWidth;
				setWidthInElement(CODE_ELEMENT_SELECTOR, width);
			});
		}
	};
});


